package cpcns.danganzhengli.mdb_wenjian.utils;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.lowagie.text.pdf.PdfReader;
import cpcns.base.common.User;
import cpcns.base.configuration.AppConfiguration;
import cpcns.danganzhengli.mdb_wenjian.service.MdbService;
import cpcns.danganzhengli.mdb_wenjian.utils.ZipUtils;
import cpcns.gongyongzujian.dianzidangan.model.DWenJianFuJian;
import cpcns.gongyongzujian.dianzidangan.service.IFuJianService;
import cpcns.gongyongzujian.dianzidangan.util.FuJianPathUtils;
import cpcns.gongyongzujian.dianzidangan.util.html5.HttpUtils;
import cpcns.gongyongzujian.dianzidangan.util.html5.ResumableInfo;
import cpcns.gongyongzujian.dianzidangan.util.html5.ResumableInfoStorage;
import cpcns.muluzhengli.service.IMuLuZhengLiService;
import cpcns.utils.CommStatic;
import it.sauronsoftware.jave.EncoderException;
import it.sauronsoftware.jave.InputFormatException;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.RandomAccessFile;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Enumeration;
import java.util.List;
import java.util.UUID;
import javax.servlet.ServletException;
import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.lang.StringUtils;
import org.apache.tools.zip.ZipEntry;
import org.apache.tools.zip.ZipFile;
import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;
import org.springframework.web.context.support.WebApplicationContextUtils;

public class YCUploadServlet extends HttpServlet {
  private static final long serialVersionUID = 1L;
  
  public static final String UPLOAD_DIR = String.valueOf(AppConfiguration.getConfigValue("OACaiJiPath")) + "/temp/";
  
  public static final String xtlx = AppConfiguration.getConfigValue("CPCNS_XITONGLEIXING");
  
  private String guanLianBiaoShi = "";
  
  private String table = "";
  
  private String menLei = "";
  
  private String hangBiaoShi = "";
  
  private String quanZongHao = "";
  
  private List<String> zipList = new ArrayList<>();
  
  private Integer cot = Integer.valueOf(0);
  
  private Boolean Record = Boolean.valueOf(true);
  
  protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    int resumableChunkNumber = getResumableChunkNumber(request);
    ResumableInfo info = getResumableInfo(request);
    this.quanZongHao = request.getParameter("quanZongHao");
    System.out.println("保存上传文件全宗号：" + this.quanZongHao);
    if ("1".equals(xtlx) && 
      RequestContextHolder.getRequestAttributes() != null) {
      HttpServletRequest request_ = ((ServletRequestAttributes)RequestContextHolder.getRequestAttributes()).getRequest();
      User user = (User)request_.getSession().getAttribute("cpcns.sso.client.filter.user");
      if (user != null && StringUtils.isNotBlank(user.getQuanZongHao())) {
        System.out.println("user===============================" + user.getQuanZongHao());
        CommStatic.setDataSource(request_, user.getQuanZongHao());
      } 
    } 
    System.out.println("临时文件路径===" + UPLOAD_DIR + "/" + this.quanZongHao + "/" + info.resumableFilename);
    File f = new File(FuJianPathUtils.obtainCiPanPath(String.valueOf(UPLOAD_DIR) + "/" + this.quanZongHao + "/" + info.resumableFilename));
    if (!f.exists()) {
      RandomAccessFile raf = new RandomAccessFile(info.resumableFilePath, "rw");
      raf.seek((resumableChunkNumber - 1) * info.resumableChunkSize);
      ServletInputStream servletInputStream = request.getInputStream();
      long readed = 0L;
      long content_length = request.getContentLength();
      byte[] bytes = new byte[102400];
      while (readed < content_length) {
        int r = servletInputStream.read(bytes);
        if (r < 0)
          break; 
        raf.write(bytes, 0, r);
        readed += r;
      } 
      raf.close();
      info.uploadedChunks.add(new ResumableInfo.ResumableChunkNumber(resumableChunkNumber));
      System.out.println("info.checkIfUploadFinished()==" + info.checkIfUploadFinished());
      if (info.checkIfUploadFinished()) {
        try {
          response.getWriter().print("All finished.");
          int filesCount = Integer.parseInt(request.getParameter("filesCount"));
          if (this.zipList.size() == 0 || this.zipList.indexOf(info.resumableFilename) == -1)
            this.zipList.add(info.resumableFilename); 
          System.out.println("zip个数==" + filesCount + "===zipList.size()=" + this.zipList.size());
          if (this.zipList.size() == filesCount) {
            System.out.println("开始解析zip");
            boolean bl = uploadYC(request, info, this.quanZongHao);
            this.zipList.clear();
            this.cot = Integer.valueOf(0);
            System.out.println("处理完成");
            if (bl) {
              ResumableInfoStorage.getInstance().remove(info);
              response.getWriter().print("All finished.");
            } else {
              response.getWriter().print("fail");
            } 
          } else {
            response.getWriter().print("All finished.");
          } 
        } catch (Exception e) {
          this.zipList.clear();
          this.cot = Integer.valueOf(0);
          e.printStackTrace();
          response.getWriter().print("fail");
        } 
      } else {
        response.getWriter().print("Upload");
      } 
    } else {
      this.zipList.clear();
      this.cot = Integer.valueOf(0);
      response.getWriter().print("fail");
    } 
  }
  
  protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    this.guanLianBiaoShi = request.getParameter("guanLianBiaoShi");
    this.hangBiaoShi = request.getParameter("hangBiaoShi");
    this.menLei = request.getParameter("menLei");
    this.table = request.getParameter("table");
    int resumableChunkNumber = getResumableChunkNumber(request);
    ResumableInfo info = getResumableInfo(request);
    if (info.uploadedChunks.contains(new ResumableInfo.ResumableChunkNumber(resumableChunkNumber))) {
      response.getWriter().print("Uploaded.");
    } else {
      response.setStatus(404);
    } 
  }
  
  private int getResumableChunkNumber(HttpServletRequest request) {
    return HttpUtils.toInt(request.getParameter("resumableChunkNumber"), -1);
  }
  
  private ResumableInfo getResumableInfo(HttpServletRequest request) throws ServletException {
    this.quanZongHao = request.getParameter("quanZongHao");
    String base_dir = String.valueOf(UPLOAD_DIR) + "/" + this.quanZongHao;
    int resumableChunkSize = HttpUtils.toInt(request.getParameter("resumableChunkSize"), -1);
    long resumableTotalSize = HttpUtils.toLong(request.getParameter("resumableTotalSize"), -1L);
    String resumableIdentifier = request.getParameter("resumableIdentifier");
    String resumableFilename = request.getParameter("resumableFilename");
    String guanLianBiaoShi = request.getParameter("guanLianBiaoShi");
    String resumableRelativePath = request.getParameter("resumableRelativePath");
    (new File(base_dir)).mkdirs();
    String resumableFilePath = String.valueOf((new File(base_dir, resumableFilename)).getAbsolutePath()) + ".temp";
    ResumableInfoStorage storage = ResumableInfoStorage.getInstance();
    ResumableInfo info = storage.get(resumableChunkSize, resumableTotalSize, 
        resumableIdentifier, resumableFilename, resumableRelativePath, resumableFilePath);
    if (!info.vaild()) {
      storage.remove(info);
      throw new ServletException("Invalid request params.");
    } 
    return info;
  }
  
  public boolean uploadYC(HttpServletRequest request, ResumableInfo info, String quanZongHao) throws InputFormatException, IOException, EncoderException {
    try {
      String mblx = request.getParameter("mblx");
      WebApplicationContext webApplicationContext = WebApplicationContextUtils.getRequiredWebApplicationContext(getServletContext());
      MdbService mdbService = (MdbService)webApplicationContext.getBean("mdbService");
      System.out.println("在导入前删除旧数据");
      mdbService.deleteMdb();
      if (mblx.equals("0")) {
        String dbPath = "";
        for (int i = 0; i < this.zipList.size(); i++) {
          String zipfilePath = FuJianPathUtils.dealBasePath(String.valueOf(UPLOAD_DIR) + quanZongHao + File.separator + (String)this.zipList.get(i));
          File targetFile = new File(zipfilePath);
          if (targetFile.exists()) {
            String fileName = zipfilePath.substring(0, zipfilePath.indexOf(".zip"));
            String mdb = ZipUtils.unZipFiles(zipfilePath, String.valueOf(fileName) + File.separator);
            if (mdb.indexOf(".mdb") >= 0)
              dbPath = mdb; 
            System.out.println(mdb);
          } 
        } 
        String filesPath = "";
        for (int y = 0; y < this.zipList.size(); y++) {
          String zipfilePath = FuJianPathUtils.dealBasePath(String.valueOf(UPLOAD_DIR) + quanZongHao + File.separator + (String)this.zipList.get(y));
          String filePath = zipfilePath.substring(0, zipfilePath.indexOf(".zip"));
          if (y == 0) {
            filesPath = getFilesPath(filePath);
          } else {
            String files2 = getFilesPath(filePath);
            copyFolder(files2, filesPath);
          } 
        } 
        File mdbFile = new File(dbPath);
        int count = 0;
        if (mdbFile.exists()) {
          count = mdbService.parsingMdbNew(filesPath, dbPath);
          if (count > 0) {
            String str = "导入成功，本次导入条目总数是" + count + "条";
            System.out.println(str);
            for (int p = 0; p < this.zipList.size(); p++)
              CommStatic.deleteDir(new File(FuJianPathUtils.dealBasePath(String.valueOf(UPLOAD_DIR) + quanZongHao + File.separator + (String)this.zipList.get(p)))); 
            this.zipList.clear();
            this.cot = Integer.valueOf(0);
            return true;
          } 
          String infom = "导入失败";
          this.zipList.clear();
          this.cot = Integer.valueOf(0);
          return false;
        } 
      } else {
        for (int i = 0; i < this.zipList.size(); i++) {
          String zipfilePath = FuJianPathUtils.dealBasePath(String.valueOf(UPLOAD_DIR) + quanZongHao + File.separator + (String)this.zipList.get(i));
          File targetFile = new File(zipfilePath);
          if (targetFile.exists()) {
            System.out.println("zip的文件==========" + zipfilePath);
            String fileName = zipfilePath.substring(0, zipfilePath.indexOf(".zip"));
            String mdb = ZipUtils.unZipFiles(zipfilePath, String.valueOf(fileName) + File.separator);
            Filefor(fileName, mdbService);
            CommStatic.deleteDir(new File(zipfilePath));
          } 
        } 
        if (this.Record.booleanValue()) {
          String str = "导入成功，本次导入条目总数是" + this.cot + "条";
          System.out.println(str);
          this.zipList.clear();
          this.cot = Integer.valueOf(0);
          return true;
        } 
        String infom = "导入失败";
        System.out.println(infom);
        this.zipList.clear();
        this.cot = Integer.valueOf(0);
        return false;
      } 
    } catch (Exception e) {
      e.printStackTrace();
      return false;
    } 
    return true;
  }
  
  protected String bytes2kb(long bytes) {
    BigDecimal fileSize = new BigDecimal(bytes);
    BigDecimal megabyte = new BigDecimal(1048576);
    float returnValue = fileSize.divide(megabyte, 2, 0)
      .floatValue();
    if (returnValue > 1.0F)
      return String.valueOf(returnValue) + "MB"; 
    BigDecimal kilobyte = new BigDecimal(1024);
    returnValue = fileSize.divide(kilobyte, 2, 0)
      .floatValue();
    return String.valueOf(returnValue) + "KB";
  }
  
  private void unZipFiles(String zipFileName, String extPlace, String mulupath) throws Exception {
    long ff = System.currentTimeMillis();
    System.out.println("开始时间=" + ff);
    System.setProperty("sun.zip.encoding", System.getProperty("sun.jnu.encoding"));
    try {
      (new File(extPlace)).mkdirs();
      File f = new File(zipFileName);
      ZipFile zipFile = new ZipFile(zipFileName, "GBK");
      if (!f.exists() && f.length() <= 0L)
        throw new Exception("要解压的文件不存在!"); 
      File ml = new File(mulupath);
      if (!ml.exists())
        ml.mkdirs(); 
      File tempFile = new File(extPlace);
      String strPath = tempFile.getAbsolutePath();
      String muluPath_ = ml.getAbsolutePath();
      Enumeration<?> e = zipFile.getEntries();
      while (e.hasMoreElements()) {
        ZipEntry zipEnt = (ZipEntry)e.nextElement();
        String gbkPath = zipEnt.getName();
        String strsubdir = gbkPath;
        for (int i = 0; i < strsubdir.length(); i++) {
          if (strsubdir.substring(i, i + 1).equalsIgnoreCase("/")) {
            String temp = FuJianPathUtils.dealBasePath(String.valueOf(muluPath_) + File.separator + strsubdir.substring(0, i));
            File subdir = new File(temp);
            if (!subdir.exists())
              subdir.mkdir(); 
          } 
        } 
        if (!zipEnt.isDirectory()) {
          String[] mingChengArr = gbkPath.split("\\.");
          String wenDangGeShi = mingChengArr[mingChengArr.length - 1];
          String uuid = UUID.randomUUID().toString();
          InputStream is = zipFile.getInputStream(zipEnt);
          BufferedInputStream bis = new BufferedInputStream(is);
          gbkPath = zipEnt.getName();
          String strtemp = String.valueOf(strPath) + File.separator + gbkPath;
          FileOutputStream fos = new FileOutputStream(strtemp);
          BufferedOutputStream bos = new BufferedOutputStream(fos);
          int c;
          while ((c = bis.read()) != -1)
            bos.write((byte)c); 
          bis.close();
          is.close();
          bos.close();
          fos.close();
        } 
      } 
      zipFile.close();
      System.out.println("结束时间=" + System.currentTimeMillis());
      System.out.println("所消耗时间=" + (System.currentTimeMillis() - ff));
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  protected String saveFile(String resumableFilePath, String yuanWenJianMing, DWenJianFuJian fuJian, String quanZongHao) throws IOException, InputFormatException, EncoderException {
    WebApplicationContext webApplicationContext = WebApplicationContextUtils.getRequiredWebApplicationContext(getServletContext());
    IMuLuZhengLiService muLuZhengLiService = (IMuLuZhengLiService)webApplicationContext.getBean("muLuZhengLiService");
    String filePath = FuJianPathUtils.obtainCiPanPath(fuJian.getCunFangLuJing());
    HttpServletRequest request_ = ((ServletRequestAttributes)RequestContextHolder.getRequestAttributes()).getRequest();
    User user = (User)request_.getSession().getAttribute("cpcns.sso.client.filter.user");
    if (user != null && StringUtils.isNotBlank(user.getQuanZongHao())) {
      System.out.println("user===============================" + user.getQuanZongHao());
      quanZongHao = user.getQuanZongHao();
    } 
    File fileFolder = new File(filePath);
    if (!fileFolder.exists())
      fileFolder.mkdirs(); 
    String realPath = String.valueOf(filePath) + yuanWenJianMing;
    Boolean fileExitFlag = Boolean.valueOf(false);
    File file = new File(realPath);
    if (file.exists()) {
      fileExitFlag = Boolean.valueOf(true);
    } else if (file.createNewFile()) {
      fileExitFlag = Boolean.valueOf(true);
    } 
    resumableFilePath = resumableFilePath.substring(0, resumableFilePath.lastIndexOf("."));
    FileInputStream fis = new FileInputStream(resumableFilePath);
    BufferedInputStream bufis = new BufferedInputStream(fis);
    FileOutputStream fos = new FileOutputStream(realPath);
    BufferedOutputStream bufos = new BufferedOutputStream(fos);
    int len = 0;
    while ((len = bufis.read()) != -1)
      bufos.write(len); 
    bufis.close();
    bufos.close();
    if (fileExitFlag.booleanValue()) {
      if (fuJian.getWenJianGeShi().equals("PDF") || fuJian.getWenJianGeShi().equals("pdf"))
        updateFenShu(realPath, fuJian.getHangBiaoShi().intValue()); 
      if (AppConfiguration.getConfigValue("CPCNS_XITONGLEIXING").equals("2"))
        muLuZhengLiService.uploadFileToFtp(fuJian.getHangBiaoShi(), quanZongHao); 
    } 
    File overFile = new File(resumableFilePath);
    if (overFile.exists())
      overFile.delete(); 
    return "";
  }
  
  protected String getPath(String table, String quanZong) {
    Calendar cal = Calendar.getInstance();
    int year = cal.get(1);
    if (StringUtils.isBlank(quanZong))
      quanZong = "001"; 
    String path = String.valueOf(quanZong) + File.separator + year + File.separator + table + File.separator + this.guanLianBiaoShi;
    path = FuJianPathUtils.dealBasePath(path);
    return path;
  }
  
  protected String getPath(String table, String quanZong, Integer yxhbs) {
    Calendar cal = Calendar.getInstance();
    int year = cal.get(1);
    if (StringUtils.isBlank(quanZong))
      quanZong = "001"; 
    String path = String.valueOf(quanZong) + File.separator + year + File.separator + table + File.separator + yxhbs + File.separator;
    path = FuJianPathUtils.dealBasePath(path);
    return path;
  }
  
  private void updateFenShu(String file, int fuJianId) throws IOException {
    WebApplicationContext webApplicationContext = WebApplicationContextUtils.getRequiredWebApplicationContext(getServletContext());
    IFuJianService fuJianService = (IFuJianService)webApplicationContext.getBean("fuJianService");
    if (StringUtils.isNotBlank(file)) {
      PdfReader reader = new PdfReader(file);
      int fenShu = reader.getNumberOfPages();
      if (fenShu > 0) {
        String fjsql = "update D_WenJianFuJian set yeShu = " + fenShu + " where hangBiaoShi = " + fuJianId;
        fuJianService.updateYeShu(fjsql);
      } 
    } 
    String wjsql = "update D_WenJian set yeShu = (select SUM(yeShu) from D_WenJianFuJian where guanLianBiaoShi in (select guanLianBiaoShi from D_WenJianFuJian where hangBiaoShi = " + fuJianId + ")) where hangBiaoShi in( select guanLianBiaoShi from D_WenJianFuJian where hangBiaoShi = " + fuJianId + ")";
    fuJianService.updateYeShu(wjsql);
  }
  
  private String getFilesPath(String filesPath) {
    String filesPath2 = String.valueOf(filesPath) + File.separator + "files";
    File files = new File(filesPath2);
    if (files.exists())
      return filesPath2; 
    File[] filesList = (new File(filesPath)).listFiles();
    int i = 0;
    if (i < filesList.length)
      return getFilesPath(filesList[i].toString()); 
    return filesPath;
  }
  
  private void Filefor(String filePath, MdbService mdbService) {
    Boolean state = Boolean.valueOf(false);
    File file = new File(filePath);
    if (file.exists()) {
      File[] fileList = file.listFiles();
      for (int i = 0; i < fileList.length; i++) {
        File files = new File(fileList[i].toString());
        if (files.isDirectory() && 
          files.getName().equals("files")) {
          state = Boolean.valueOf(true);
          String filesPath = String.valueOf(filePath) + File.separator + "files";
          String dbPath = getDbPath(String.valueOf(filePath) + File.separator + "db");
          Integer c = Integer.valueOf(mdbService.parsingMdbNew(filesPath, dbPath));
          if (c.intValue() > 0) {
            this.cot = Integer.valueOf(this.cot.intValue() + c.intValue());
          } else {
            this.Record = Boolean.valueOf(false);
            return;
          } 
        } 
      } 
      if (!state.booleanValue())
        for (int y = 0; y < fileList.length; y++)
          Filefor(fileList[y].toString(), mdbService);  
    } else {
      this.Record = Boolean.valueOf(false);
      return;
    } 
  }
  
  public String getDbPath(String filePath) {
    File file = new File(filePath);
    File[] fileList = file.listFiles();
    for (int i = 0; i < fileList.length; i++) {
      File dbFile = new File(fileList[i].toString());
      if (dbFile.isDirectory()) {
        getDbPath(fileList[i].toString());
      } else if (dbFile.getName().indexOf(".mdb") >= 0 || dbFile.getName().toUpperCase().indexOf(".MDB") >= 0) {
        return fileList[i].toString();
      } 
    } 
    return filePath;
  }
  
  public void copyFolder(String oldPath, String newPath) {
    try {
      (new File(newPath)).mkdirs();
      File a = new File(oldPath);
      String[] file = a.list();
      File temp = null;
      for (int i = 0; i < file.length; i++) {
        if (oldPath.endsWith(File.separator)) {
          temp = new File(String.valueOf(oldPath) + file[i]);
        } else {
          temp = new File(String.valueOf(oldPath) + File.separator + file[i]);
        } 
        if (temp.isFile()) {
          FileInputStream input = new FileInputStream(temp);
          FileOutputStream output = new FileOutputStream(String.valueOf(newPath) + "/" + 
              temp.getName().toString());
          byte[] b = new byte[5120];
          int len;
          while ((len = input.read(b)) != -1)
            output.write(b, 0, len); 
          output.flush();
          output.close();
          input.close();
        } 
        if (temp.isDirectory())
          copyFolder(String.valueOf(oldPath) + "/" + file[i], String.valueOf(newPath) + "/" + file[i]); 
      } 
    } catch (Exception e) {
      System.out.println("复制整个文件夹内容操作出错");
      e.printStackTrace();
    } 
  }
}
